package com.redhat.xpaas.qe;

import org.apache.camel.Exchange;
import org.apache.camel.Processor;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class CounterProcessor implements Processor {
	private static final transient Logger LOG = LoggerFactory.getLogger(CounterProcessor.class);

	public void process(Exchange exchange) throws Exception {
		Long count = 0L;
		if (exchange.getIn().getHeader("count", Long.class) != null) {
			count = exchange.getIn().getHeader("count", Long.class);
		}
		String cid = exchange.getIn().getHeader("cid", String.class);
		Long delay = 0L;
		if (exchange.getIn().getHeader("delay", Long.class) != null) {
			delay = exchange.getIn().getHeader("delay", Long.class);
		}

		Long c = count + 1;

		LOG.info("count before delay {} {}", cid, c);
		Thread.sleep(delay == null ? 0 : delay);
		LOG.info("count after delay {} {}", cid, c);

		exchange.getOut().setBody(UuidBean.uuid() + " " + c);
	}
}
